//
//  FILE NAME:
//      FpsCounter.h
//
//  AUTHOR(S):
//      Rafal Kocisz <rafal.kocisz@gmail.com>
//

#ifndef __FPS_COUNTER_H__
#define __FPS_COUNTER_H__

#include <e32base.h>

class CFpsCounter : public CBase
    {
public:
	static CFpsCounter* NewL( TInt aInterval );

    ~CFpsCounter();

    TInt Fps();
    TInt Frames();
    void SetInterval( TInt aInterval );

    void Update();

private:
    CFpsCounter( TInt aInterval );

    TInt iSecs;
    TInt iInterval;
    TInt iFrames;
    TInt iSeconds;
    TInt iStartTicks;
    TInt iTicksPerSecond;
    TInt iFps;

    }; // class CFpsCounter

#endif // #ifndef __FPS_COUNTER_H__

// Eof
