//
//  FILE NAME:
//      CGameSkeletonContainer.h
//
//  AUTHOR(S):
//      Rafal Kocisz <rafal.kocisz@gmail.com>
//

#ifndef __GAME_SKELETON_CONTAINER_H__
#define __GAME_SKELETON_CONTAINER_H__

#include "KeyState.h"

#include <coecntrl.h>

class CFpsCounter;

class CGameSkeletonContainer
    : public CCoeControl
    {
public:
    static TInt Tick( TAny* aCallback );

    ~CGameSkeletonContainer();
    void ConstructL( const TRect& aRect );

    void FocusChanged( TDrawNow aDrawNow );
    void SizeChanged();
    TInt CountComponentControls() const;
    CCoeControl* ComponentControl( TInt aIndex ) const;
    TKeyResponse OfferKeyEventL(
        const TKeyEvent& aKeyEvent,
        TEventCode aType );

private:
    void Draw( const TRect& aRect ) const;

    void StartTickGenerator();
    void StopTickGenerator();
    void OnTick();

    void Draw( CGraphicsContext& aGc ) const;
    void Update( TInt64 aDt );

    CWsBitmap* iBackupBitmap;
    CFbsBitmapDevice* iBitmapDevice;
    CFbsBitGc* iBitmapGc;
    CFpsCounter* iFpsCounter;
    CPeriodic* iTickGenerator;
    TTime iTickStart;
    TTime iTickStop;
    TKeyState iKeyState;

    }; // class CGameSkeletonContainer

#endif // #ifndef __GAME_SKELETON_CONTAINER_H__

// Eof
