//
//  FILE NAME:
//      FpsCounter.cpp
//
//  AUTHOR(S):
//      Rafal Kocisz <rafal.kocisz@gmail.com>
//

#include "FpsCounter.h"

#include <hal.h>

CFpsCounter* CFpsCounter::NewL( TInt aInterval )
    {
    CFpsCounter* self
        = new ( ELeave ) CFpsCounter( aInterval );
    return self;
    }

CFpsCounter::CFpsCounter( TInt aInterval )
    {
    HAL::Get( HALData::ESystemTickPeriod, iTicksPerSecond );
    iTicksPerSecond = 1000000 / iTicksPerSecond;
    SetInterval( aInterval );
    iFrames = 0;
    iSeconds = 0;
    iStartTicks = User::TickCount();
    }

CFpsCounter::~CFpsCounter()
    {
    }

int CFpsCounter::Fps()
    {
    return iFps;
    }

void CFpsCounter::SetInterval( TInt aInterval )
    {
    iSecs = aInterval;
    iInterval = iTicksPerSecond * aInterval;
    }


void CFpsCounter::Update()
    {
    TInt cticks = User::TickCount();
    iFrames++;

    if ( ( cticks - iStartTicks ) > iInterval )
        {
        TInt dif = cticks - iStartTicks;
        iFps = ( ( iFrames * ( iTicksPerSecond ) ) / dif );
        iFrames = 0;
        iSeconds += iSecs;
        iStartTicks = User::TickCount();
        }
    }

// Eof
